#!/usr/bin/env sh

set -e

script_dir="$(dirname "$0")"
project_dir="$script_dir/../.."

VERSION="$1"
if [ -z "$VERSION" ]; then
  echo "Error: version must be passed as first argument" >&2
  exit 1
fi

echo "Updating template files ..."

templates="templates/*.yml"
templates_exclude="templates/delete-state.yml templates/module-release.yml templates/__internal_id_tokens_base_job.yml"

for relative_template_file in $templates; do
  if echo "$templates_exclude" | grep -q "$relative_template_file"; then continue; fi
  template_file="$project_dir/$relative_template_file"
  tmp_template_file=$(mktemp)
  echo "Updating $template_file ... "
  yq eval-all '
    select(document_index == 0).spec.inputs.version.default
     = "'"$VERSION"'"
    ' "$template_file" > "$tmp_template_file"
  diff -Bw "$template_file" "$tmp_template_file" | patch "$template_file" -
done
